function sequence(...handlers) {
  const length = handlers.length;
  if (!length)
    return (context, resolve) => resolve(context);
  return (context, resolve) => {
    return apply_handle(0, context);
    function apply_handle(i, handleContext) {
      const handle = handlers[i];
      return handle(handleContext, (nextContext) => {
        return i < length - 1 ? apply_handle(i + 1, nextContext) : resolve(nextContext);
      });
    }
  };
}
export {
  sequence
};
