/// <reference types="node" />
import type http from 'http';
import type { ComponentInstance, ManifestData, RouteData } from '../@types/astro';
import type { ComponentPreload, DevelopmentEnvironment } from '../core/render/dev/index';
import type { ModuleLoader } from '../core/module-loader';
import type { AstroMiddlewareInstance } from '../@types/astro';
type AsyncReturnType<T extends (...args: any) => Promise<any>> = T extends (...args: any) => Promise<infer R> ? R : any;
interface MatchedRoute {
    route: RouteData;
    filePath: URL;
    resolvedPathname: string;
    preloadedComponent: ComponentPreload;
    mod: ComponentInstance;
}
export declare function matchRoute(pathname: string, env: DevelopmentEnvironment, manifest: ManifestData): Promise<MatchedRoute | undefined>;
/**
 * It accepts a module loader and the astro settings, and it attempts to load the middlewares defined in the configuration.
 *
 * If not middlewares were not set, the function returns an empty array.
 */
export declare function loadMiddlewares(moduleLoader: ModuleLoader, basePath: URL, middlewareOrder: string[]): Promise<AstroMiddlewareInstance[]>;
export declare function handleRoute(matchedRoute: AsyncReturnType<typeof matchRoute>, url: URL, pathname: string, body: ArrayBuffer | undefined, origin: string, env: DevelopmentEnvironment, manifest: ManifestData, req: http.IncomingMessage, res: http.ServerResponse): Promise<void>;
export {};
